searchNodes=[{"doc":"Bintreeviz is a binary tree visualizer for Elixir. Its main purpose is to convert a given tree structure into a string representation. Positioning It supports pluggable algorithms for positioning of the individual nodes. Out-of-the-box it comeswith the Wetherell and Shannon (WS) algorithm for drawing tidy trees as described in IEEE. Rendering It supports pluggable renderers for outputting the positioned tree to a string format. out-of-the-box it comes with an ASCII renderer which will use a configurable charset to draw the tree. Configuration options The renderer takes a keyword list with configuration options: renderer Which renderer to use. It will default to the ASCII (Bintreeviz.Renderer.Ascii) renderer which will render the tree using Box Drawing Characters and can be printed to stdout as shown in the examples. positioner Which positioning algorithm to use. It defaults to Wetherell and Shannon (WS). ascii_renderer_charset Renderer specific configuration to configure which charset to use while rendering using the ASCII renderer. Defaults to Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars. Other options are: Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.","ref":"Bintreeviz.html","title":"Bintreeviz","type":"module"},{"doc":"render/1 takes the root node, positions it and then renders it into a string","ref":"Bintreeviz.html#render/2","title":"Bintreeviz.render/2","type":"function"},{"doc":"","ref":"Bintreeviz.html#t:render_options/0","title":"Bintreeviz.render_options/0","type":"type"},{"doc":"Bintreeviz.Node describes a single Node in the graph and contains the functions to manipulate said Nodes.","ref":"Bintreeviz.Node.html","title":"Bintreeviz.Node","type":"module"},{"doc":"is_leaf/1 returns true if the node has no left_child and no right_child.","ref":"Bintreeviz.Node.html#is_leaf?/1","title":"Bintreeviz.Node.is_leaf?/1","type":"function"},{"doc":"new/1 takes a string label and returns a new %Node{}","ref":"Bintreeviz.Node.html#new/1","title":"Bintreeviz.Node.new/1","type":"function"},{"doc":"new/2 takes a string label and an Keyword list containing left and right children and returns a new %Node{}","ref":"Bintreeviz.Node.html#new/2","title":"Bintreeviz.Node.new/2","type":"function"},{"doc":"set_left_child/2 assigns the passed in node as the left_child to the node.","ref":"Bintreeviz.Node.html#set_left_child/2","title":"Bintreeviz.Node.set_left_child/2","type":"function"},{"doc":"set_right_child/2 assigns the passed in node as the right_child to the node.","ref":"Bintreeviz.Node.html#set_right_child/2","title":"Bintreeviz.Node.set_right_child/2","type":"function"},{"doc":"width/1 returns the width of the node. Width of the node is determined by the length of the label plus the configured padding for the nodes.","ref":"Bintreeviz.Node.html#width/1","title":"Bintreeviz.Node.width/1","type":"function"},{"doc":"","ref":"Bintreeviz.Node.html#t:node_children/0","title":"Bintreeviz.Node.node_children/0","type":"type"},{"doc":"","ref":"Bintreeviz.Node.html#t:t/0","title":"Bintreeviz.Node.t/0","type":"type"},{"doc":"Bintreeviz.Positioner describes the behaviour for implementing a positioner. Out of the box Bintreeviz will provide the WS implementation. Implementing another positioner is as easy as providing a module with a position/1 function which will take the root node and returns the fully positioned root node.","ref":"Bintreeviz.Positioner.html","title":"Bintreeviz.Positioner","type":"behaviour"},{"doc":"","ref":"Bintreeviz.Positioner.html#c:position/1","title":"Bintreeviz.Positioner.position/1","type":"callback"},{"doc":"Module to do the positioning following the WS algorithm. As described in the original paper, this algorithm works with two loops to keep the algorithm performing in O(N).","ref":"Bintreeviz.Positioner.WS.html","title":"Bintreeviz.Positioner.WS","type":"module"},{"doc":"position/1 takes the root node and positions it and all its child nodes accordingly","ref":"Bintreeviz.Positioner.WS.html#position/1","title":"Bintreeviz.Positioner.WS.position/1","type":"function"},{"doc":"Bintreeviz.Renderer describes the behaviour for implementing a renderer. Out of the box Bintreeviz will provide a ASCII renderer which will turn the provided graph into a stringified representation using configurable box drawing characters.","ref":"Bintreeviz.Renderer.html","title":"Bintreeviz.Renderer","type":"behaviour"},{"doc":"","ref":"Bintreeviz.Renderer.html#c:render/2","title":"Bintreeviz.Renderer.render/2","type":"callback"},{"doc":"Simple ASCII rendering module which, given a tree structure, render its nodes to STDOUT using ASCII characters such as dashes and pipes. Its implemented quite naively but we&#39;ll fix that in a next iteration.","ref":"Bintreeviz.Renderer.Ascii.html","title":"Bintreeviz.Renderer.Ascii","type":"module"},{"doc":"render/1 takes the starting node and converts it to a rendered representation using ASCII characters","ref":"Bintreeviz.Renderer.Ascii.html#render/2","title":"Bintreeviz.Renderer.Ascii.render/2","type":"function"},{"doc":"Bintreeviz.Renderer.Ascii.Charset describes the behaviour to define various charsets to be used to draw the trees.","ref":"Bintreeviz.Renderer.Ascii.Charset.html","title":"Bintreeviz.Renderer.Ascii.Charset","type":"behaviour"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:bottom_left_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.bottom_left_corner/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:bottom_right_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.bottom_right_corner/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:child_left_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.child_left_turn_char/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:child_right_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.child_right_turn_char/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:horizontal_line/0","title":"Bintreeviz.Renderer.Ascii.Charset.horizontal_line/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:node_connector_bottom/0","title":"Bintreeviz.Renderer.Ascii.Charset.node_connector_bottom/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:node_connector_top/0","title":"Bintreeviz.Renderer.Ascii.Charset.node_connector_top/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:parent_left_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.parent_left_turn_char/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:parent_right_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.parent_right_turn_char/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:parent_split_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.parent_split_char/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:top_left_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.top_left_corner/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:top_right_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.top_right_corner/0","type":"callback"},{"doc":"","ref":"Bintreeviz.Renderer.Ascii.Charset.html#c:vertical_line/0","title":"Bintreeviz.Renderer.Ascii.Charset.vertical_line/0","type":"callback"},{"doc":"BoxDrawingChars defines the characters to use for drawing tidy boxes following the Box Drawing Characters","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars","type":"module"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.bottom_left_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#bottom_left_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.bottom_left_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.bottom_right_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#bottom_right_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.bottom_right_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.child_left_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#child_left_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.child_left_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.child_right_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#child_right_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.child_right_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.horizontal_line/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#horizontal_line/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.horizontal_line/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.node_connector_bottom/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#node_connector_bottom/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.node_connector_bottom/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.node_connector_top/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#node_connector_top/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.node_connector_top/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.parent_left_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#parent_left_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.parent_left_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.parent_right_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#parent_right_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.parent_right_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.parent_split_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#parent_split_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.parent_split_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.top_left_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#top_left_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.top_left_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.top_right_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#top_right_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.top_right_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.vertical_line/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.html#vertical_line/0","title":"Bintreeviz.Renderer.Ascii.Charset.BoxDrawingChars.vertical_line/0","type":"function"},{"doc":"SimpleDrawingChars defines the characters to use for drawing simple boxes with dashes, pipes and plus signs.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars","type":"module"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.bottom_left_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#bottom_left_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.bottom_left_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.bottom_right_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#bottom_right_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.bottom_right_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.child_left_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#child_left_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.child_left_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.child_right_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#child_right_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.child_right_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.horizontal_line/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#horizontal_line/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.horizontal_line/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.node_connector_bottom/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#node_connector_bottom/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.node_connector_bottom/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.node_connector_top/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#node_connector_top/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.node_connector_top/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.parent_left_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#parent_left_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.parent_left_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.parent_right_turn_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#parent_right_turn_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.parent_right_turn_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.parent_split_char/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#parent_split_char/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.parent_split_char/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.top_left_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#top_left_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.top_left_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.top_right_corner/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#top_right_corner/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.top_right_corner/0","type":"function"},{"doc":"Callback implementation for Bintreeviz.Renderer.Ascii.Charset.vertical_line/0.","ref":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.html#vertical_line/0","title":"Bintreeviz.Renderer.Ascii.Charset.SimpleDrawingChars.vertical_line/0","type":"function"},{"doc":"🌳 Bintreeviz Bintreeviz is a binary tree visualizer for Elixir. Its main purpose is to convert a given tree structure into a string representation. Out of the box it supports the Wetherell and Shannon alhorithm as described in their 1979 publication of Tidy Drawings of Trees in IEEE and renders to ASCII characters using the Box Drawing Character set, but all of these are configurable options.","ref":"readme.html","title":"🌳 Bintreeviz","type":"extras"},{"doc":"Building the tree alias Bintreeviz.Node root = Node.new(&quot;Root&quot;, left_child: Node.new(&quot;Node A&quot;, left_child: Node.new(&quot;Node C&quot;), right_child: Node.new(&quot;Node D&quot;) ), right_child: Node.new(&quot;Node B&quot;, left_child: Node.new(&quot;Node E&quot;), right_child: Node.new(&quot;Node F&quot;) ) ) Rendering the tree root |&gt; Bintreeviz.render() |&gt; IO.puts() The result: ┏━━━━━━┓ ┃ Root ┃ ┗━━━┳━━┛ ┏━━━━━━━━━━━┻━━━━━━━━━━━┓ ┏━━━━┻━━━┓ ┏━━━━┻━━━┓ ┃ Node A ┃ ┃ Node B ┃ ┗━━━━┳━━━┛ ┗━━━━┳━━━┛ ┏━━━━━┻━━━━━┓ ┏━━━━━┻━━━━━┓ ┏━━━━┻━━━┓ ┏━━━━┻━━━┓ ┏━━━━┻━━━┓ ┏━━━━┻━━━┓ ┃ Node C ┃ ┃ Node D ┃ ┃ Node E ┃ ┃ Node F ┃ ┗━━━━━━━━┛ ┗━━━━━━━━┛ ┗━━━━━━━━┛ ┗━━━━━━━━┛","ref":"readme.html#example","title":"🌳 Bintreeviz - Example","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding bintreeviz to your list of dependencies in mix.exs: def deps do [ {:bintreeviz, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/bintreeviz.","ref":"readme.html#installation","title":"🌳 Bintreeviz - Installation","type":"extras"}]